%global debug_package %{nil}
%global app_id io.github.arunsivaramanneo.GPUViewer
%global forgeurl https://github.com/arunsivaramanneo/GPU-Viewer
%global commit 230efbad797e9f3e25984142c0b540d667d9e786
%global date 20241021
%forgemeta

Name:           gpu-viewer
Version:        3.06
Release:        1%{?dist}
License:        GPL-3.0
Summary:        A front-end to glxinfo, vulkaninfo, clinfo and es2_info
URL:            %{forgeurl}
Source:         %{forgesource}

#------------------------------------------------------------------

BuildRequires:  ImageMagick
BuildRequires:  desktop-file-utils
BuildRequires:  gcc
BuildRequires:  gettext
BuildRequires:  glib2-devel
BuildRequires:  gtk-update-icon-cache
BuildRequires:  hicolor-icon-theme
BuildRequires:  libappstream-glib
BuildRequires:  meson
BuildRequires:  ninja-build
BuildRequires:  python3-devel

Requires:       clinfo
Requires:       egl-utils
Requires:       glx-utils
Requires:       gtk4
Requires:       libadwaita
Requires:       lsb_release
Requires:       python3-click
Requires:       python3-gobject
Requires:       vdpauinfo
Requires:       vulkan-tools
Requires:       xdpyinfo
Requires:       mesa-demos

#------------------------------------------------------------------

%description
%{summary}

This project aims to capture all the important details of glxinfo, vulkaninfo
and clinfo in a GUI. The project is being developed using python 3 pygobject
with GTK4. All the important details are extracted using
glxinfo/vulkaninfo/clinfo with the combination of grep, CAT , AWK commands and
displayed in the front-end. There is no hard OpenGL Programming involved, until
glxinfo, vulkaninfo and clinfo works the GPU-viewer will also work

%files
%license LICENSE
%doc README.md
%{_bindir}/%{name}
%{_datadir}/%{name}
%{_datadir}/applications/%{app_id}.desktop
%{_datadir}/icons/hicolor/*/apps/%{app_id}.png
%{_datadir}/icons/hicolor/512x512/apps/*.png
%{_metainfodir}/%{app_id}.metainfo.xml

#------------------------------------------------------------------

%prep
%forgeautosetup -p1

%build
%meson
%meson_build

%install
%meson_install

# fix desktop file
sed -i '/Version/d' %{buildroot}%{_datadir}/applications/%{app_id}.desktop

# icons install
for x in 16 32 24 48 64 96 128 256; do
convert -resize ${x}x${x} %{buildroot}%{_datadir}/icons/hicolor/512x512/apps/%{app_id}.png %{name}.png
install -Dm0644 %{name}.png %{buildroot}%{_datadir}/icons/hicolor/${x}x${x}/apps/%{app_id}.png
done

%py_byte_compile %{python3} %{buildroot}%{_datadir}/%{name}/Files/*.py

%check
desktop-file-validate %{buildroot}%{_datadir}/applications/%{app_id}.desktop
appstream-util validate-relax --nonet %{buildroot}%{_metainfodir}/%{app_id}.metainfo.xml

#------------------------------------------------------------------

%changelog
* Tue Nov 5 2024 Hazel Bunny <hazel_bunny@disroot.org> - 3.06-1
- Initial package

